#ifndef DESKTOP_H
#define DESKTOP_H

#include <stdio.h>
#include <string.h>

#include "card.h"
#include "ctlist.h"
#include "coloda.h"
#include "gamer.h"

#define version "0.1.0"

//----------------------------------------------------
class TDeskTop {
	public:
		TColoda *Coloda;
		Tclist  *Gamers;
		Tncounter nCurrentStart,nCurrentMove;
		TCard *FirstCard,*SecondCard,*TherdCard;
		TCard *CardOnDesk[4];
		TDeskTop(void);
		~TDeskTop();
		TGamer * InsertGamer(TGamer *);
		void RunGame(void);
		int nPlayerTakeCards(TCard *p1,TCard *p2,TCard *p3,int koz );
		//     int nBuletScore;

		void ShowPaper(void);
		void CloseBullet(void);

	private:
		void InternalConstruct(void);
		void insertscore(Tclist *,char *);
		void replace(char *,char , char);
		TGamer *GetGamerByNum(int );
		int GetGamerWithMaxBullet(void); // exept closed gamers
		TCard *ControlingMakemove(TCard *,TCard *);	
		TCard *PipeMakemove(TCard *lMove,TCard *rMove);
		void GamerAssign(TGamer *,TGamer *);
};

//----------------------------------------------------
char *Tclist2pchar(Tclist *,char *);
//----------------------------------------------------

#endif


