#include "prfconst.h"

#include <stdio.h>
#include <limits.h>
#include "ncounter.h"
#include "gamer.h"
#include "desktop.h"
#include "plscore.h"
#include "humang.h"

//-------------------------------------------------------------
#define ENDOFTORG  if ( (GamesType[1] != undefined &&    GamesType[2] != undefined && GamesType[3] != undefined )&& ((GamesType[1] == pass ? 1:0)+(GamesType[2] == pass ? 1:0)+(GamesType[3] == pass ? 1:0) >= 2 )) break;
//-------------------------------------------------------------
typedef struct {
	int m,b,lv, rv;
} TRospis;
//-------------------------------------------------------------
void TDeskTop::InternalConstruct(void) {
  CardOnDesk[0] = CardOnDesk[1] = CardOnDesk[2] = CardOnDesk[3] = FirstCard=SecondCard=TherdCard=NULL;
  Coloda = new TColoda(CARDINCOLODA);
  Gamers = new Tclist(4); // 1...3

  nCurrentStart.nValue=nCurrentMove.nValue=2;
  nCurrentStart.nMin=nCurrentMove.nMin=1;
  nCurrentStart.nMax=nCurrentMove.nMax=3;
  
  InsertGamer(new TGamer(0));
  // I Hate This Game :)
  //InsertGamer(new TGamer(1));
  
  InsertGamer(new THuman(1));

  InsertGamer(new TGamer(2));
  InsertGamer(new TGamer(3));

  Gamers -> AtFree(0);
  nBuletScore =  21;
}


//-------------------------------------------------------------
TDeskTop::TDeskTop(void) {
  InternalConstruct();
}
//-------------------------------------------------------------
TDeskTop::~TDeskTop() {
  delete Coloda;
  delete Gamers;
}
//-------------------------------------------------------------
void TDeskTop::CloseBullet(void) {
	Tncounter counter(1,1,3);
	int mb=INT_MAX,mm=INT_MAX,i;
	TRospis R[4];
	TGamer *G;
	for (i=1;i<=3;i++) {
		G = GetGamerByNum(i);
		R[i].m = G->aScore -> nGetMount();
		R[i].b = G->aScore -> nGetBull();
		R[i].lv = G->aScore -> nGetLeftVists();
		R[i].rv = G->aScore -> nGetRightVists();
		if ( R[i].m < mm ) 	mm = R[i].m;
		if ( R[i].b < mb ) 	mb = R[i].b;
	}
	// Amnistiya gori
	for (i=1;i<=3;i++) R[i].m -= mm;
	// Amnistiya puli
	for (i=1;i<=3;i++) R[i].b -= mb;
	// svou pulu sebe v visti
	for (i=1;i<=3;i++) {
		R[i].lv +=	R[i].b*10 /3;
		R[i].rv +=	R[i].b*10 /3;
		
	}
	// goru - drugim na sebya
	for (i=1;i<=3;i++) {
		counter.nValue = i;
		++counter;
		R[counter.nValue].rv += 	R[i].m*10 /3;
		++counter;
		R[counter.nValue].lv += 	R[i].m*10 /3;
		
	}
	// schitaem visti
	for (i=1;i<=3;i++) {
		int i1,i2;
		counter.nValue = i;
		++counter;
		i1 = counter.nValue;
		++counter;
		i2 = counter.nValue;
		GetGamerByNum(i)	->aScore ->Vists = R[i].lv + R[i].rv - R[i1].rv - R[i2].lv;	
	}
}
//-------------------------------------------------------------
TGamer * TDeskTop::InsertGamer(TGamer *Gamer) {
  Gamers -> Insert(Gamer);
  return Gamer;
}
//-------------------------------------------------------------
void TDeskTop::GamerAssign(TGamer *newgamer,TGamer *oldgamer) {
	newgamer -> aCards -> Assign(oldgamer-> aCards);
	newgamer -> aLeft -> Assign(oldgamer-> aLeft);
	newgamer -> aRight -> Assign(oldgamer-> aRight);
	newgamer -> aOut -> Assign(oldgamer-> aOut);	
	newgamer -> aCardsOut -> Assign(oldgamer-> aCardsOut);
	newgamer -> aLeftOut -> Assign(oldgamer-> aLeftOut);	
	newgamer -> aRightOut -> Assign(oldgamer-> aRightOut);
	newgamer -> nGetsCard = oldgamer -> nGetsCard;
	newgamer -> Mast = oldgamer -> Mast;	
	newgamer -> GamesType = oldgamer -> GamesType;	
	newgamer -> Enemy = oldgamer -> Enemy;	
	newgamer -> nCardClosed = oldgamer -> nCardClosed;			
	//newgamer -> DeskView = oldgamer ->DeskView;
	newgamer -> Pronesti= oldgamer ->Pronesti;
}

//-------------------------------------------------------------
TCard *TDeskTop::PipeMakemove(TCard *lMove,TCard *rMove) {
	return (GetGamerByNum(nCurrentMove.nValue)) ->makemove(lMove,rMove,
    	      GetGamerByNum(NextGamer(nCurrentMove)),GetGamerByNum(PrevGamer(nCurrentMove)));
}
//-------------------------------------------------------------
TCard *TDeskTop::ControlingMakemove(TCard *lMove,TCard *rMove) {
//     1     (      ) ,
//    THuman   
//   1          TGamer
	TCard *RetVal = NULL;
	TGamer *Now = GetGamerByNum(nCurrentMove.nValue);
		if ((GetGamerByNum(1)->GamesType == vist || GetGamerByNum(1)->GamesType == g86catch) && Now->nGamer!=1 && (Now->GamesType==pass || Now->GamesType==g86catch)) {
			THuman *NewHuman = new THuman(nCurrentMove.nValue);

			GamerAssign(NewHuman,Now);
			Gamers -> AtPut(nCurrentMove.nValue,NewHuman);
		
			RetVal = NewHuman -> makemove(lMove,rMove,
    	      GetGamerByNum(NextGamer(nCurrentMove)),GetGamerByNum(PrevGamer(nCurrentMove)));
			GamerAssign(Now,NewHuman);
			Gamers -> AtPut(nCurrentMove.nValue,Now);				
			NewHuman->set0();
			delete NewHuman;	
		} else if(Now -> nGamer == 1 && Now ->GamesType==pass) {
			TGamer *NewHuman = new TGamer(nCurrentMove.nValue);
			GamerAssign(NewHuman,Now);
			Gamers -> AtPut(nCurrentMove.nValue,NewHuman);
				
			RetVal = NewHuman -> makemove(lMove,rMove,
      	    GetGamerByNum(NextGamer(nCurrentMove)),GetGamerByNum(PrevGamer(nCurrentMove)));
			GamerAssign(Now,NewHuman);
			Gamers -> AtPut(nCurrentMove.nValue,Now);
			NewHuman->set0();
			delete NewHuman;				
		} else {

				RetVal = PipeMakemove(lMove,rMove);

	}

	return RetVal;
}
//-------------------------------------------------------------
void TDeskTop::RunGame(void) {

  // ------------- feal --------------
  char CName[50]; //  
  char CName2[50]; //  2
  TCard *Card; 
  int f, i;
  // ---------------------------------

  TGamesType GamesType[4];

  int npasscounter;

   printf("tpref: version %s (2000-03)\n\n", version);

   printf("   Kodi igr:\n");
   printf("---------------\n");
   printf("g61  - 6 pik\n");
   printf("   . . .\n");
   printf("g65  - 6 BK\n");
   printf("g71  - 7 tref\n");
   printf("   . . .\n");
   printf("g105 - 10 BK\n");
   printf("g86  - Mizer\n");
   printf("pass - Pas\n");
   printf("vist - Vist\n");
   printf("---------------\n\n");

  // -------------------------- feal -----------------------------------------
  printf("\nVvedite razmer puli: "); scanf("%i", &nBuletScore);
  // -------------------------------------------------------------------------


  while ( !( GetGamerByNum(1)->aScore->nGetBull()>=nBuletScore &&
             GetGamerByNum(2)->aScore->nGetBull()>=nBuletScore &&
             GetGamerByNum(3)->aScore->nGetBull()>=nBuletScore)   ) { // while ! 
    Tncounter GamersCounter(1,1,3);
    int  nPl;
    int nGamernumber = 0 ; //   
    int nPassCounter = 0;  // - 
    GamesType[3]=GamesType[2]=GamesType[1]=GamesType[0]=undefined;
    CardOnDesk[0] = CardOnDesk[1] = CardOnDesk[2] = CardOnDesk[3] = FirstCard=SecondCard=TherdCard=NULL;
    
	delete Coloda;
    Coloda = new TColoda(CARDINCOLODA);
    Coloda -> Mix();

	GetGamerByNum(1) ->set0();
    GetGamerByNum(2) ->set0();
    GetGamerByNum(3) ->set0();
    
	CurrentGame = undefined;

	    for (i=0;i<(CARDINCOLODA-2);i++ ) { //  
  		    TGamer * tmpGamer = GetGamerByNum(GamersCounter.nValue);
    		  tmpGamer -> AddCard( (TCard *)Coloda->At(i)) ;
    		  ++GamersCounter;
	    }
	
  // --------------------------------feal -------------------------------
  printf("\n\n-----------------------------------------------");

  printf("\n\n--Vashi karti--\n");
  GetGamerByNum(1)->aCards->mySort(); //    1
  for(f = 0; f < 10; f++) {
	  Card = (TCard *) GetGamerByNum(1)->aCards->At(f);
	  printf("Card(%i) = %s \n", f, CardName(Card, CName));
  }
  // ---------------------------------------------------------------------


    GamersCounter = nCurrentStart;

	printf("\nZahodit igrok N%i\n\n",nCurrentStart.nValue);

    npasscounter=0;
    while ( npasscounter < 2 ) {     //    2   
      if ( GamesType[1] != pass )
          GamesType[1] = GetGamerByNum(GamersCounter.nValue) -> makemove (GamesType[2],GamesType[3]);
      printf("Igrok N%i skazal: %s\n", nCurrentStart.nValue, sGameName(GamesType[1]));

      ++GamersCounter;
      ENDOFTORG

      if ( GamesType[2] != pass )
          GamesType[2] = GetGamerByNum(GamersCounter.nValue) -> makemove(GamesType[3],GamesType[1]);
      printf("Igrok N%i skazal: %s\n", GamersCounter.nValue, sGameName(GamesType[2]));

      ++GamersCounter;
      ENDOFTORG

      if ( GamesType[3] != pass )
        GamesType[3] = GetGamerByNum(GamersCounter.nValue) -> makemove(GamesType[1],GamesType[2]);
      printf("Igrok  N%i skazal: %s\n", GamersCounter.nValue, sGameName(GamesType[3]));

      ++GamersCounter;
      ENDOFTORG
    }

    for (i=1;i<=3;i++ ) { // .  
      if ( GamesType[0] < GamesType[i] ) {
        GamesType[0] = GamesType[i];
      }
    }


    if ( GamesType[0] !=pass ) { //  
      for ( int i=1;i<=3;i++ ) { //     
        TGamer *tmpg=GetGamerByNum(i);
        if ( tmpg -> GamesType==GamesType[0] ) {

		  nPassCounter = 0;
          Tncounter tmpGamersCounter(1,3)/*,tmpGamersCounter2(1,3)*/;
          TGamer *PassOrVistGamers;
          int PassOrVist = 0,nPassOrVist = 0;

	      CardOnDesk[2] = (TCard *)Coloda->At(30);
  		  CardOnDesk[3] = (TCard *)Coloda->At(31);

          printf("\nBerem is prikupa: %s , %s\n\n",CardName(CardOnDesk[2], CName),CardName(CardOnDesk[3], CName2));

          //   
          tmpg -> AddCard((TCard *)Coloda->At(30));
          tmpg -> AddCard((TCard *)Coloda->At(31));

          nGamernumber = tmpg -> nGamer;
 
		  if ( tmpg -> GamesType != g86 ) { //  
            nCurrentMove.nValue = i;
            GamesType[0] = CurrentGame = tmpg -> makeout4game();
            printf("Igrok N%i skazal: %s\n", nGamernumber, sGameName(GamesType[0]));

          } else {
			  //   
        	  int tempint = nCurrentMove.nValue;
      		  int nVisibleState = tmpg ->nCardClosed ;
			  tmpg ->nCardClosed = 0 ;
			  
			  //   
	          tmpg -> nCardClosed = nVisibleState;
	          nCurrentMove.nValue = tmpg ->nGamer;
			  GamesType[0] = CurrentGame = tmpg -> makeout4miser();
			  nCurrentMove.nValue = tempint ;
          }
          tmpGamersCounter.nValue = i;

          //   
          ++tmpGamersCounter;
          PassOrVistGamers=GetGamerByNum(tmpGamersCounter.nValue);
          PassOrVistGamers -> GamesType = undefined;

          PassOrVist = PassOrVistGamers -> makemove(CurrentGame,pass,0);
          nPassOrVist = tmpGamersCounter.nValue;
          if (PassOrVistGamers ->GamesType == pass ) nPassCounter++;

          
          printf("Igrok N%i skazal: %s\n", tmpGamersCounter.nValue, sGameName(PassOrVistGamers ->GamesType));

          ++tmpGamersCounter;
          PassOrVistGamers=GetGamerByNum(tmpGamersCounter.nValue);
          PassOrVistGamers -> GamesType = undefined;

          PassOrVistGamers -> makemove(CurrentGame,PassOrVist,nPassOrVist);

          printf("Igrok N%i skazal: %s\n", tmpGamersCounter.nValue, sGameName(PassOrVistGamers ->GamesType));
          
		  
		  if (PassOrVistGamers ->GamesType == pass ) nPassCounter++;
          if (nPassCounter==2) {
            //   :)
            tmpg -> nGetsCard = nGetGameCard(tmpg ->GamesType);
            printf("\nDvoe spasovali!\n");

            goto LabelRecordOnPaper;

          } else {  //    
            for ( int ntmp = 2 ; ntmp <= 3 ; ntmp++ ) {
                TGamer *Gamer4Open;
                Gamer4Open = GetGamerByNum(ntmp);
                if  (nPassCounter || CurrentGame == g86 ) { //   2 
                    if ( Gamer4Open -> GamesType == pass || Gamer4Open -> GamesType == vist || Gamer4Open -> GamesType == g86catch)
                        Gamer4Open -> nCardClosed = 0;
                }
            }
          }
          break;
        }
      } //     
    }  else { //  
      GamesType[0] = CurrentGame = raspass;
      GetGamerByNum(1) ->GamesType =  raspass;
      GetGamerByNum(2) ->GamesType =  raspass;
      GetGamerByNum(3) ->GamesType =  raspass;
    }
    nCurrentMove=nCurrentStart;
    

	for (i=1;i<=10;i++ ) {
      TGamer *tmpg;
      CardOnDesk[0] = CardOnDesk[1] = CardOnDesk[2] = CardOnDesk[3] = FirstCard=SecondCard=TherdCard=NULL;
      if (CurrentGame == raspass && (i>=1 && i<=3 ))
              nCurrentMove=nCurrentStart;
      if ( CurrentGame == raspass && (i==1 || i==2)) {
	      TCard *tmp4show;
	      TCard *ptmp4rpass;
	        	tmp4show = (TCard *)Coloda->At(29+i);
  			   	ptmp4rpass =  new TCard( 1,tmp4show-> CMast );

                printf("\nPrikup: %s\n",CardName(tmp4show, CName));


        FirstCard = ControlingMakemove((TCard*) NULL,  ptmp4rpass);
        delete ptmp4rpass;
      }  else {
        FirstCard = ControlingMakemove((TCard*) NULL,  (TCard*) NULL);
      }

      
      printf("\nPervaya karta: %s\n",CardName(FirstCard, CName));


      ++nCurrentMove;


      SecondCard = ControlingMakemove((TCard*) NULL,FirstCard);

	  printf("Vtoraya karta: %s\n",CardName(SecondCard, CName));


      ++nCurrentMove;


      TherdCard = ControlingMakemove(FirstCard,SecondCard);
      printf("Tretya karta : %s\n",CardName(TherdCard, CName));


	  ++nCurrentMove;


      nPl = nPlayerTakeCards(FirstCard,SecondCard,TherdCard,GamesType[0] - (GamesType[0]/10)*10 ) - 1;
      
	  nCurrentMove = nCurrentMove +  nPl;
      tmpg = (TGamer *)Gamers->At(nCurrentMove.nValue);
      tmpg -> nGetsCard ++;


	  printf("\nVzyatka Igroka: %i  Vsego vsyatok: %i\n", nCurrentMove.nValue, tmpg -> nGetsCard);

    }

LabelRecordOnPaper:

    ++nCurrentStart;
    //   
    for (i = 1; i<= 3;i++ ) {
        TGamer * tmpg = GetGamerByNum(i);
        TGamer * Gamer = GetGamerByNum(nGamernumber);
        int RetValAddRec = tmpg -> aScore -> AddRecords (CurrentGame,
                tmpg->GamesType ,
                Gamer !=NULL ? Gamer -> nGetsCard : 0,
                tmpg->nGetsCard,
                Gamer !=NULL ? nGamernumber : 0, i, 2-nPassCounter);

				if ( RetValAddRec ) {
						int index = GetGamerWithMaxBullet();
						if (index) {
							tmpg ->aScore -> AddVist(index,i,RetValAddRec) ; //    
							RetValAddRec =   GetGamerByNum(index) -> aScore -> AddBullet(RetValAddRec); //   
							if (RetValAddRec) {
								index = GetGamerWithMaxBullet();
								if (index) {
									tmpg ->aScore -> AddVist(index,i,RetValAddRec) ; //    
									RetValAddRec =  GetGamerByNum(index) -> aScore -> AddBullet(RetValAddRec);
									if (RetValAddRec) {
										tmpg->aScore->MountanDown(RetValAddRec);
									}
								} else {
									tmpg->aScore->MountanDown(RetValAddRec);			
								}
							}
						} else {
							tmpg->aScore->MountanDown(RetValAddRec);			
						}
				}
	}

	
	CloseBullet();

    //   -     
			for (int k = 1; k<=3;k++) {
				TCardList *tmplist;
				TGamer * Gamer = GetGamerByNum(k);
				tmplist = Gamer -> aCards;
				Gamer -> aCards = Gamer -> aCardsOut;			
				Gamer -> nCardClosed = 0;
				Gamer -> aCardsOut = Gamer -> aCards;
				Gamer -> aCards = tmplist;
			}

    // ------- feal ------
    ShowPaper();
	// -------------------
  } //  

    //ShowPaper();
}

//-------------------------------------------------------------
int TDeskTop::GetGamerWithMaxBullet(void) {
		int MaxBullet= -1,CurrBullet=-1,RetVal=0;
		for (int i =1 ;i<=3;i++) {
			 CurrBullet = GetGamerByNum(i) -> aScore -> nGetBull();
				if (MaxBullet < CurrBullet && CurrBullet < nBuletScore ) {
					MaxBullet = CurrBullet;					
					RetVal = i;
				}
		}
		return RetVal;
}
//-------------------------------------------------------------
int TDeskTop::nPlayerTakeCards(TCard *p1,TCard *p2,TCard *p3,int koz ) {
    TCard *Max = p1;
    int nRelVal = 1;
    if ( (Max->CMast == p2->CMast && Max->CName < p2->CName) || (Max->CMast != koz && p2->CMast == koz) ) {
        Max = p2;
        nRelVal = 2;
    }
    if ( (Max->CMast == p3->CMast && Max->CName < p3->CName) || (Max->CMast != koz && p3->CMast == koz) ) {
        Max = p3;
        nRelVal = 3;
    }
    return nRelVal;
}
//-------------------------------------------------------------
char *Tclist2pchar(Tclist *List,char *cRetVal) {
        char buff[1024];
        int nIndex=-1,nItemVal=0;
        int *pnItemVal=NULL;
        strcpy(cRetVal,"");
        while (1) {
          pnItemVal = (int *)List ->NextItem(nIndex++);
          if (!pnItemVal) return cRetVal;
//          if (pnItemVal)
             nItemVal = *pnItemVal;
//          else
//             nItemVal =0;
					itoa(nItemVal,buff,10);
          strcat(cRetVal,buff);
          strcat(cRetVal,".");
        }
//        return cRetVal;
}
//-------------------------------------------------------------
TGamer *TDeskTop::GetGamerByNum(int num) {
    return (TGamer *)Gamers->At(num);
}
//-------------------------------------------------------------
void TDeskTop::replace(char *str,char csource, char cdestination) {
    while ( *str ) {
        if ( *str == csource )
            *str = cdestination;
        str++;
    }
}
//-------------------------------------------------------------
void TDeskTop::insertscore(Tclist *list,char *pbuff) {
        int nVal;
        while ( sscanf(pbuff,"%i",&nVal) !=EOF  ) {
            if (nVal)
                list->Insert(new int (nVal));
            pbuff = strchr(pbuff,' ')+1;
        }
}
//-------------------------------------------------------------

void TDeskTop::ShowPaper(void) {
    char *sb = new char[1024];
    char *sm = new char[1024];
    char *slv = new char[1024];
    char *srv = new char[1024];
    char *tv = new char[1024];

    printf("\n------ Pulya ------\n");

    for (int i = 1;i<=3;i++) {
        TGamer *Gamer = GetGamerByNum(i);
        sb = Tclist2pchar ( Gamer->aScore->Bullet,sb);
        sm = Tclist2pchar (Gamer->aScore->Mountan,sm);
        slv = Tclist2pchar(Gamer->aScore->LeftVists,slv);
        srv = Tclist2pchar(Gamer->aScore->RightVists,srv);
        printf("\nIgrok (%i): %i vistov\n",i,Gamer->aScore->Vists);
    }
    printf("-------------------\n");

    delete sb;
		delete sm;
		delete slv;

		delete srv;
		delete tv;
} 
//-------------------------------------------------------------
